-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Data Grid - Cell Customization
JavaScript DataGrid allows you to modify cell style settings and custom paint cells in a PDF document.
Use the customizeCell function to customize the appearance settings of JavaScript DataGrid cells in a PDF document. For example, you can change the text alignment and the background color of cells. The following function parameters are available:
- gridCell
Contains information about the source JavaScript DataGrid cell. - pdfCell
Contains settings applied to a cell in a PDF document.
Backend API
// This code is used for backwards compatibility with the older jsPDF variable name
// Read more: https://github.com/MrRio/jsPDF/releases/tag/v2.0.0
window.jsPDF = window.jspdf.jsPDF;
$(() => {
$('#gridContainer').dxDataGrid({
dataSource: companies,
keyExpr: 'ID',
width: '100%',
showBorders: true,
groupPanel: {
visible: true,
},
grouping: {
autoExpandAll: true,
},
sortByGroupSummaryInfo: [{
summaryItem: 'count',
}],
export: {
enabled: true,
formats: ['pdf'],
},
onExporting(e) {
const doc = new jsPDF();
DevExpress.pdfExporter.exportDataGrid({
jsPDFDocument: doc,
component: e.component,
columnWidths: [40, 40, 30, 30, 40],
customizeCell({ gridCell, pdfCell }) {
if (gridCell.rowType === 'data' && gridCell.column.dataField === 'Phone') {
pdfCell.text = pdfCell.text.replace(/(\d{3})(\d{3})(\d{4})/, '($1) $2-$3');
} else if (gridCell.rowType === 'group') {
pdfCell.backgroundColor = '#BEDFE6';
} else if (gridCell.rowType === 'totalFooter') {
pdfCell.font.style = 'italic';
}
},
customDrawCell(options) {
const { gridCell, pdfCell } = options;
if (gridCell.rowType === 'data' && gridCell.column.dataField === 'Website') {
options.cancel = true;
doc.setFontSize(11);
doc.setTextColor('#0000FF');
const textHeight = doc.getTextDimensions(pdfCell.text).h;
doc.textWithLink('website',
options.rect.x + pdfCell.padding.left,
options.rect.y + options.rect.h / 2 + textHeight / 2,
{ url: pdfCell.text });
}
},
}).then(() => {
doc.save('Companies.pdf');
});
},
columns: [{
dataField: 'Name',
width: 190,
}, {
dataField: 'Address',
width: 200,
},
'City',
{
dataField: 'State',
groupIndex: 0,
}, {
dataField: 'Phone',
format(value) {
const USNumber = value.match(/(\d{3})(\d{3})(\d{4})/);
return `(${USNumber[1]}) ${USNumber[2]}-${USNumber[3]}`;
},
}, {
dataField: 'Website',
alignment: 'center',
width: 100,
cellTemplate(container, options) {
return $('<a>', { href: options.value, target: '_blank' }).text('Website');
},
}],
summary: {
totalItems: [{
column: 'Name',
summaryType: 'count',
displayFormat: 'Total count: {0}',
}],
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script
type="text/javascript"
src="https://cdnjs.cloudflare.com/ajax/libs/jspdf/3.0.3/jspdf.umd.min.js"
integrity="sha512-+EeCylkt9WHJk5tGJxYdecHOcXFRME7qnbsfeMsdQL6NUPYm2+uGFmyleEqsmVoap/f3dN/sc3BX9t9kHXkHHg=="
crossorigin="anonymous"
></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="gridContainer"></div>
</div>
</body>
</html>
#gridContainer {
height: 436px;
}
const companies = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
Zipcode: 72716,
Phone: '8005552797',
Fax: '(800) 555-2171',
Website: 'http://nowebsitesupermart.dx',
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
Zipcode: 30339,
Phone: '8005953232',
Fax: '(800) 595-3231',
Website: 'http://nowebsitedepot.dx',
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
Zipcode: 55403,
Phone: '6123046073',
Fax: '(612) 304-6074',
Website: 'http://nowebsitemusic.dx',
}, {
ID: 4,
Name: "Tom's Club",
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
Zipcode: 98027,
Phone: '8009552292',
Fax: '(800) 955-2293',
Website: 'http://nowebsitetomsclub.dx',
}, {
ID: 5,
Name: 'E-Mart',
Address: '3333 Beverly Rd',
City: 'Hoffman Estates',
State: 'Illinois',
Zipcode: 60179,
Phone: '8472862500',
Fax: '(847) 286-2501',
Website: 'http://nowebsiteemart.dx',
}, {
ID: 6,
Name: 'Walters',
Address: '200 Wilmot Rd',
City: 'Deerfield',
State: 'Illinois',
Zipcode: 60015,
Phone: '8479402500',
Fax: '(847) 940-2501',
Website: 'http://nowebsitewalters.dx',
}, {
ID: 7,
Name: 'StereoShack',
Address: '400 Commerce S',
City: 'Fort Worth',
State: 'Texas',
Zipcode: 76102,
Phone: '8178200741',
Fax: '(817) 820-0742',
Website: 'http://nowebsiteshack.dx',
}, {
ID: 8,
Name: 'Circuit Town',
Address: '2200 Kensington Court',
City: 'Oak Brook',
State: 'Illinois',
Zipcode: 60523,
Phone: '8009552929',
Fax: '(800) 955-9392',
Website: 'http://nowebsitecircuittown.dx',
}, {
ID: 9,
Name: 'Premier Buy',
Address: '7601 Penn Avenue South',
City: 'Richfield',
State: 'Minnesota',
Zipcode: 55423,
Phone: '6122911000',
Fax: '(612) 291-2001',
Website: 'http://nowebsitepremierbuy.dx',
}, {
ID: 10,
Name: 'ElectrixMax',
Address: '263 Shuman Blvd',
City: 'Naperville',
State: 'Illinois',
Zipcode: 60563,
Phone: '6304387800',
Fax: '(630) 438-7801',
Website: 'http://nowebsiteelectrixmax.dx',
}, {
ID: 11,
Name: 'Video Emporium',
Address: '1201 Elm Street',
City: 'Dallas',
State: 'Texas',
Zipcode: 75270,
Phone: '2148543000',
Fax: '(214) 854-3001',
Website: 'http://nowebsitevideoemporium.dx',
}, {
ID: 12,
Name: 'Screen Shop',
Address: '1000 Lowes Blvd',
City: 'Mooresville',
State: 'North Carolina',
Zipcode: 28117,
Phone: '8004456937',
Fax: '(800) 445-6938',
Website: 'http://nowebsitescreenshop.dx',
}];
In this demo, the customizeCell function changes the following elements:
- Background color and font weight of group row cells
- Font style of a footer cell
The customDrawCell function allows you to draw cells in a PDF document. The following parameters are available when you use this function:
- doc
An instance of the jsPDFDocument object. - rect
A cell’s bounds. - gridCell
Contains information about the source JavaScript DataGrid cell. - pdfCell
Contains settings applied to a cell in a PDF document. - cancel
Set this parameter to true to prevent default painting logic.
This demo uses the customDrawCell function to paint cells in the "Website" column.

Backend API
<template>
<div>
<DxDataGrid
id="gridContainer"
:key-expr="'ID'"
:data-source="companies"
:width="'100%'"
:show-borders="true"
@exporting="onExporting"
>
<DxExport
:enabled="true"
:formats="['pdf']"
/>
<DxGroupPanel :visible="true"/>
<DxGrouping :auto-expand-all="true"/>
<DxSortByGroupSummaryInfo summary-item="count"/>
<DxColumn
data-field="Name"
:width="190"
/>
<DxColumn
data-field="Address"
:width="200"
/>
<DxColumn data-field="City"/>
<DxColumn
data-field="State"
:group-index="0"
/>
<DxColumn
data-field="Phone"
:format="phoneNumberFormat"
/>
<DxColumn
data-field="Website"
alignment="center"
:width="100"
cell-template="grid-cell"
/>
<template #grid-cell="{ data }">
<a
:href="data.text"
target="_blank"
>
Website
</a>
</template>
/>
<DxSummary>
<DxTotalItem
column="Name"
summary-type="count"
display-format="Total count: {0}"
/>
</DxSummary>
</DxDataGrid>
</div>
</template>
<script setup lang="ts">
import {
DxDataGrid,
DxColumn,
DxGrouping,
DxGroupPanel,
DxExport,
DxSummary,
DxSortByGroupSummaryInfo,
DxTotalItem,
type DxDataGridTypes,
} from 'devextreme-vue/data-grid';
import { exportDataGrid, type DataGridCell, type Cell as PdfCell } from 'devextreme-vue/common/export/pdf';
import { jsPDF } from 'jspdf';
import { companies } from './data.ts';
const onExporting = (e: DxDataGridTypes.ExportingEvent) => {
const doc = new jsPDF();
exportDataGrid({
jsPDFDocument: doc,
component: e.component,
columnWidths: [40, 40, 30, 30, 40],
customizeCell({ gridCell, pdfCell }: { gridCell?: DataGridCell, pdfCell?: PdfCell }) {
if (!(pdfCell?.font && pdfCell.text)) {
return;
}
if (gridCell?.rowType === 'data' && gridCell?.column?.dataField === 'Phone') {
pdfCell.text = pdfCell.text.replace(/(\d{3})(\d{3})(\d{4})/, '($1) $2-$3');
} else if (gridCell?.rowType === 'group') {
pdfCell.backgroundColor = '#BEDFE6';
} else if (gridCell?.rowType === 'totalFooter') {
pdfCell.font.style = 'italic';
}
},
customDrawCell(options) {
const { gridCell, pdfCell } = options;
if (options.rect
&& pdfCell?.text
&& pdfCell.padding?.left
&& gridCell?.rowType === 'data'
&& gridCell.column?.dataField === 'Website') {
options.cancel = true;
doc.setFontSize(11);
doc.setTextColor('#0000FF');
const textHeight = doc.getTextDimensions(pdfCell.text).h;
doc.textWithLink('website',
options.rect.x + pdfCell.padding.left,
options.rect.y + options.rect.h / 2 + textHeight / 2,
{ url: pdfCell.text });
}
},
}).then(() => {
doc.save('Companies.pdf');
});
};
const phoneNumberFormat = (value: string) => {
const USNumber = value.match(/(\d{3})(\d{3})(\d{4})/)!;
return `(${USNumber[1]}) ${USNumber[2]}-${USNumber[3]}`;
};
</script>
<style scoped>
#gridContainer {
height: 436px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'fflate': 'npm:fflate/esm/browser.js',
'jspdf': 'npm:jspdf@4.2.1/dist/jspdf.umd.min.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export type Company = {
ID: number;
Name: string;
Address: string;
City: string;
State: string;
Zipcode: number;
Phone: string;
Fax: string;
Website: string;
};
export const companies: Company[] = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
Zipcode: 72716,
Phone: '8005552797',
Fax: '(800) 555-2171',
Website: 'http://nowebsitesupermart.dx',
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
Zipcode: 30339,
Phone: '8005953232',
Fax: '(800) 595-3231',
Website: 'http://nowebsitedepot.dx',
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
Zipcode: 55403,
Phone: '6123046073',
Fax: '(612) 304-6074',
Website: 'http://nowebsitemusic.dx',
}, {
ID: 4,
Name: 'Tom\'s Club',
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
Zipcode: 98027,
Phone: '8009552292',
Fax: '(800) 955-2293',
Website: 'http://nowebsitetomsclub.dx',
}, {
ID: 5,
Name: 'E-Mart',
Address: '3333 Beverly Rd',
City: 'Hoffman Estates',
State: 'Illinois',
Zipcode: 60179,
Phone: '8472862500',
Fax: '(847) 286-2501',
Website: 'http://nowebsiteemart.dx',
}, {
ID: 6,
Name: 'Walters',
Address: '200 Wilmot Rd',
City: 'Deerfield',
State: 'Illinois',
Zipcode: 60015,
Phone: '8479402500',
Fax: '(847) 940-2501',
Website: 'http://nowebsitewalters.dx',
}, {
ID: 7,
Name: 'StereoShack',
Address: '400 Commerce S',
City: 'Fort Worth',
State: 'Texas',
Zipcode: 76102,
Phone: '8178200741',
Fax: '(817) 820-0742',
Website: 'http://nowebsiteshack.dx',
}, {
ID: 8,
Name: 'Circuit Town',
Address: '2200 Kensington Court',
City: 'Oak Brook',
State: 'Illinois',
Zipcode: 60523,
Phone: '8009552929',
Fax: '(800) 955-9392',
Website: 'http://nowebsitecircuittown.dx',
}, {
ID: 9,
Name: 'Premier Buy',
Address: '7601 Penn Avenue South',
City: 'Richfield',
State: 'Minnesota',
Zipcode: 55423,
Phone: '6122911000',
Fax: '(612) 291-2001',
Website: 'http://nowebsitepremierbuy.dx',
}, {
ID: 10,
Name: 'ElectrixMax',
Address: '263 Shuman Blvd',
City: 'Naperville',
State: 'Illinois',
Zipcode: 60563,
Phone: '6304387800',
Fax: '(630) 438-7801',
Website: 'http://nowebsiteelectrixmax.dx',
}, {
ID: 11,
Name: 'Video Emporium',
Address: '1201 Elm Street',
City: 'Dallas',
State: 'Texas',
Zipcode: 75270,
Phone: '2148543000',
Fax: '(214) 854-3001',
Website: 'http://nowebsitevideoemporium.dx',
}, {
ID: 12,
Name: 'Screen Shop',
Address: '1000 Lowes Blvd',
City: 'Mooresville',
State: 'North Carolina',
Zipcode: 28117,
Phone: '8004456937',
Fax: '(800) 445-6938',
Website: 'http://nowebsitescreenshop.dx',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
In this demo, the customizeCell function changes the following elements:
- Background color and font weight of group row cells
- Font style of a footer cell
The customDrawCell function allows you to draw cells in a PDF document. The following parameters are available when you use this function:
- doc
An instance of the jsPDFDocument object. - rect
A cell’s bounds. - gridCell
Contains information about the source DataGrid cell. - pdfCell
Contains settings applied to a cell in a PDF document. - cancel
Set this parameter to true to prevent default painting logic.
This demo uses the customDrawCell function to paint cells in the "Website" column.

Backend API
import React from 'react';
import { jsPDF } from 'jspdf';
import DataGrid, {
Column, Summary, GroupPanel, Grouping, SortByGroupSummaryInfo, TotalItem, Export,
} from 'devextreme-react/data-grid';
import type { DataGridTypes } from 'devextreme-react/data-grid';
import { exportDataGrid } from 'devextreme-react/common/export/pdf';
import type { DataGridExportOptions } from 'devextreme-react/common/export/pdf';
import { companies } from './data.ts';
type CustomizeCellOptions = Parameters<Required<DataGridExportOptions>['customizeCell']>[number];
type CustomDrawCellOptions = Parameters<Required<DataGridExportOptions>['customDrawCell']>[number];
const exportFormats = ['pdf'];
const onExporting = (e: DataGridTypes.ExportingEvent) => {
const doc = new jsPDF();
exportDataGrid({
jsPDFDocument: doc,
component: e.component,
columnWidths: [40, 40, 30, 30, 40],
customizeCell({ gridCell, pdfCell }: CustomizeCellOptions) {
if (gridCell?.rowType === 'data' && gridCell?.column?.dataField === 'Phone' && pdfCell?.text) {
pdfCell.text = pdfCell.text.replace(/(\d{3})(\d{3})(\d{4})/, '($1) $2-$3');
} else if (gridCell?.rowType === 'group' && pdfCell) {
pdfCell.backgroundColor = '#BEDFE6';
} else if (gridCell?.rowType === 'totalFooter' && pdfCell?.font) {
pdfCell.font.style = 'italic';
}
},
customDrawCell(options: CustomDrawCellOptions) {
const { gridCell, pdfCell, rect } = options;
if (gridCell && pdfCell && rect && gridCell.rowType === 'data' && gridCell.column?.dataField === 'Website') {
options.cancel = true;
doc.setFontSize(11);
doc.setTextColor('#0000FF');
const textHeight = pdfCell.text ? doc.getTextDimensions(pdfCell.text).h : 0;
doc.textWithLink('website',
rect.x + (pdfCell.padding?.left ?? 0),
rect.y + rect.h / 2 + textHeight / 2,
{ url: pdfCell.text });
}
},
}).then(() => {
doc.save('Companies.pdf');
});
};
const renderGridCell = (data: DataGridTypes.ColumnCellTemplateData) => (
<a href={ data.text } target='_blank' rel='noopener noreferrer'>Website</a>
);
const phoneNumberFormat = (value: number) => {
const valueStr = String(value);
const USNumber = valueStr.match(/(\d{3})(\d{3})(\d{4})/);
return USNumber ? `(${USNumber[1]}) ${USNumber[2]}-${USNumber[3]}` : '';
};
const App = () => (
<div>
<DataGrid
id="gridContainer"
dataSource={companies}
keyExpr="ID"
width="100%"
showBorders={true}
onExporting={onExporting}>
<Export enabled={true} formats={exportFormats} />
<GroupPanel visible={true} />
<Grouping autoExpandAll={true} />
<SortByGroupSummaryInfo summaryItem="count" />
<Column dataField="Name" width={190} />
<Column dataField="Address" width={200} />
<Column dataField="City" />
<Column dataField="State" groupIndex={0} />
<Column dataField="Phone" format={phoneNumberFormat} />
<Column dataField="Website" alignment="center" width={100} cellRender={(e: DataGridTypes.ColumnCellTemplateData) => renderGridCell(e)} />
<Summary>
<TotalItem
column="Name"
summaryType="count"
displayFormat="Total count: {0}"
/>
</Summary>
</DataGrid>
</div>
);
export default App;
import React from 'react';
import { jsPDF } from 'jspdf';
import DataGrid, {
Column,
Summary,
GroupPanel,
Grouping,
SortByGroupSummaryInfo,
TotalItem,
Export,
} from 'devextreme-react/data-grid';
import { exportDataGrid } from 'devextreme-react/common/export/pdf';
import { companies } from './data.js';
const exportFormats = ['pdf'];
const onExporting = (e) => {
const doc = new jsPDF();
exportDataGrid({
jsPDFDocument: doc,
component: e.component,
columnWidths: [40, 40, 30, 30, 40],
customizeCell({ gridCell, pdfCell }) {
if (
gridCell?.rowType === 'data' &&
gridCell?.column?.dataField === 'Phone' &&
pdfCell?.text
) {
pdfCell.text = pdfCell.text.replace(/(\d{3})(\d{3})(\d{4})/, '($1) $2-$3');
} else if (gridCell?.rowType === 'group' && pdfCell) {
pdfCell.backgroundColor = '#BEDFE6';
} else if (gridCell?.rowType === 'totalFooter' && pdfCell?.font) {
pdfCell.font.style = 'italic';
}
},
customDrawCell(options) {
const { gridCell, pdfCell, rect } = options;
if (
gridCell &&
pdfCell &&
rect &&
gridCell.rowType === 'data' &&
gridCell.column?.dataField === 'Website'
) {
options.cancel = true;
doc.setFontSize(11);
doc.setTextColor('#0000FF');
const textHeight = pdfCell.text ? doc.getTextDimensions(pdfCell.text).h : 0;
doc.textWithLink(
'website',
rect.x + (pdfCell.padding?.left ?? 0),
rect.y + rect.h / 2 + textHeight / 2,
{ url: pdfCell.text },
);
}
},
}).then(() => {
doc.save('Companies.pdf');
});
};
const renderGridCell = (data) => (
<a
href={data.text}
target="_blank"
rel="noopener noreferrer"
>
Website
</a>
);
const phoneNumberFormat = (value) => {
const valueStr = String(value);
const USNumber = valueStr.match(/(\d{3})(\d{3})(\d{4})/);
return USNumber ? `(${USNumber[1]}) ${USNumber[2]}-${USNumber[3]}` : '';
};
const App = () => (
<div>
<DataGrid
id="gridContainer"
dataSource={companies}
keyExpr="ID"
width="100%"
showBorders={true}
onExporting={onExporting}
>
<Export
enabled={true}
formats={exportFormats}
/>
<GroupPanel visible={true} />
<Grouping autoExpandAll={true} />
<SortByGroupSummaryInfo summaryItem="count" />
<Column
dataField="Name"
width={190}
/>
<Column
dataField="Address"
width={200}
/>
<Column dataField="City" />
<Column
dataField="State"
groupIndex={0}
/>
<Column
dataField="Phone"
format={phoneNumberFormat}
/>
<Column
dataField="Website"
alignment="center"
width={100}
cellRender={(e) => renderGridCell(e)}
/>
<Summary>
<TotalItem
column="Name"
summaryType="count"
displayFormat="Total count: {0}"
/>
</Summary>
</DataGrid>
</div>
);
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const companies = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
Zipcode: 72716,
Phone: '8005552797',
Fax: '(800) 555-2171',
Website: 'http://nowebsitesupermart.dx',
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
Zipcode: 30339,
Phone: '8005953232',
Fax: '(800) 595-3231',
Website: 'http://nowebsitedepot.dx',
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
Zipcode: 55403,
Phone: '6123046073',
Fax: '(612) 304-6074',
Website: 'http://nowebsitemusic.dx',
}, {
ID: 4,
Name: 'Tom\'s Club',
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
Zipcode: 98027,
Phone: '8009552292',
Fax: '(800) 955-2293',
Website: 'http://nowebsitetomsclub.dx',
}, {
ID: 5,
Name: 'E-Mart',
Address: '3333 Beverly Rd',
City: 'Hoffman Estates',
State: 'Illinois',
Zipcode: 60179,
Phone: '8472862500',
Fax: '(847) 286-2501',
Website: 'http://nowebsiteemart.dx',
}, {
ID: 6,
Name: 'Walters',
Address: '200 Wilmot Rd',
City: 'Deerfield',
State: 'Illinois',
Zipcode: 60015,
Phone: '8479402500',
Fax: '(847) 940-2501',
Website: 'http://nowebsitewalters.dx',
}, {
ID: 7,
Name: 'StereoShack',
Address: '400 Commerce S',
City: 'Fort Worth',
State: 'Texas',
Zipcode: 76102,
Phone: '8178200741',
Fax: '(817) 820-0742',
Website: 'http://nowebsiteshack.dx',
}, {
ID: 8,
Name: 'Circuit Town',
Address: '2200 Kensington Court',
City: 'Oak Brook',
State: 'Illinois',
Zipcode: 60523,
Phone: '8009552929',
Fax: '(800) 955-9392',
Website: 'http://nowebsitecircuittown.dx',
}, {
ID: 9,
Name: 'Premier Buy',
Address: '7601 Penn Avenue South',
City: 'Richfield',
State: 'Minnesota',
Zipcode: 55423,
Phone: '6122911000',
Fax: '(612) 291-2001',
Website: 'http://nowebsitepremierbuy.dx',
}, {
ID: 10,
Name: 'ElectrixMax',
Address: '263 Shuman Blvd',
City: 'Naperville',
State: 'Illinois',
Zipcode: 60563,
Phone: '6304387800',
Fax: '(630) 438-7801',
Website: 'http://nowebsiteelectrixmax.dx',
}, {
ID: 11,
Name: 'Video Emporium',
Address: '1201 Elm Street',
City: 'Dallas',
State: 'Texas',
Zipcode: 75270,
Phone: '2148543000',
Fax: '(214) 854-3001',
Website: 'http://nowebsitevideoemporium.dx',
}, {
ID: 12,
Name: 'Screen Shop',
Address: '1000 Lowes Blvd',
City: 'Mooresville',
State: 'North Carolina',
Zipcode: 28117,
Phone: '8004456937',
Fax: '(800) 445-6938',
Website: 'http://nowebsitescreenshop.dx',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'fflate': 'npm:fflate/esm/browser.js',
'jspdf': 'npm:jspdf@4.2.1/dist/jspdf.umd.min.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const companies = [
{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
Zipcode: 72716,
Phone: '8005552797',
Fax: '(800) 555-2171',
Website: 'http://nowebsitesupermart.dx',
},
{
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
Zipcode: 30339,
Phone: '8005953232',
Fax: '(800) 595-3231',
Website: 'http://nowebsitedepot.dx',
},
{
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
Zipcode: 55403,
Phone: '6123046073',
Fax: '(612) 304-6074',
Website: 'http://nowebsitemusic.dx',
},
{
ID: 4,
Name: "Tom's Club",
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
Zipcode: 98027,
Phone: '8009552292',
Fax: '(800) 955-2293',
Website: 'http://nowebsitetomsclub.dx',
},
{
ID: 5,
Name: 'E-Mart',
Address: '3333 Beverly Rd',
City: 'Hoffman Estates',
State: 'Illinois',
Zipcode: 60179,
Phone: '8472862500',
Fax: '(847) 286-2501',
Website: 'http://nowebsiteemart.dx',
},
{
ID: 6,
Name: 'Walters',
Address: '200 Wilmot Rd',
City: 'Deerfield',
State: 'Illinois',
Zipcode: 60015,
Phone: '8479402500',
Fax: '(847) 940-2501',
Website: 'http://nowebsitewalters.dx',
},
{
ID: 7,
Name: 'StereoShack',
Address: '400 Commerce S',
City: 'Fort Worth',
State: 'Texas',
Zipcode: 76102,
Phone: '8178200741',
Fax: '(817) 820-0742',
Website: 'http://nowebsiteshack.dx',
},
{
ID: 8,
Name: 'Circuit Town',
Address: '2200 Kensington Court',
City: 'Oak Brook',
State: 'Illinois',
Zipcode: 60523,
Phone: '8009552929',
Fax: '(800) 955-9392',
Website: 'http://nowebsitecircuittown.dx',
},
{
ID: 9,
Name: 'Premier Buy',
Address: '7601 Penn Avenue South',
City: 'Richfield',
State: 'Minnesota',
Zipcode: 55423,
Phone: '6122911000',
Fax: '(612) 291-2001',
Website: 'http://nowebsitepremierbuy.dx',
},
{
ID: 10,
Name: 'ElectrixMax',
Address: '263 Shuman Blvd',
City: 'Naperville',
State: 'Illinois',
Zipcode: 60563,
Phone: '6304387800',
Fax: '(630) 438-7801',
Website: 'http://nowebsiteelectrixmax.dx',
},
{
ID: 11,
Name: 'Video Emporium',
Address: '1201 Elm Street',
City: 'Dallas',
State: 'Texas',
Zipcode: 75270,
Phone: '2148543000',
Fax: '(214) 854-3001',
Website: 'http://nowebsitevideoemporium.dx',
},
{
ID: 12,
Name: 'Screen Shop',
Address: '1000 Lowes Blvd',
City: 'Mooresville',
State: 'North Carolina',
Zipcode: 28117,
Phone: '8004456937',
Fax: '(800) 445-6938',
Website: 'http://nowebsitescreenshop.dx',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gridContainer {
height: 436px;
}
In this demo, the customizeCell function changes the following elements:
- Background color and font weight of group row cells
- Font style of a footer cell
The customDrawCell function allows you to draw cells in a PDF document. The following parameters are available when you use this function:
- doc
An instance of the jsPDFDocument object. - rect
A cell’s bounds. - gridCell
Contains information about the source DataGrid cell. - pdfCell
Contains settings applied to a cell in a PDF document. - cancel
Set this parameter to true to prevent default painting logic.
This demo uses the customDrawCell function to paint cells in the "Website" column.

Backend API
<dx-data-grid
id="gridContainer"
[dataSource]="companies"
[keyExpr]="'ID'"
[width]="'100%'"
[showBorders]="true"
(onExporting)="onExporting($event)"
>
<dxo-data-grid-export
[enabled]="true"
[formats]="['pdf']"
></dxo-data-grid-export>
<dxo-data-grid-group-panel [visible]="true"></dxo-data-grid-group-panel>
<dxo-data-grid-grouping [autoExpandAll]="true"></dxo-data-grid-grouping>
<dxi-data-grid-sort-by-group-summary-info
summaryItem="count"
></dxi-data-grid-sort-by-group-summary-info>
<dxi-data-grid-column dataField="Name" [width]="190"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Address"
[width]="200"
></dxi-data-grid-column>
<dxi-data-grid-column dataField="City"></dxi-data-grid-column>
<dxi-data-grid-column
dataField="State"
[groupIndex]="0"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Phone"
[format]="phoneNumberFormat"
></dxi-data-grid-column>
<dxi-data-grid-column
dataField="Website"
alignment="center"
[width]="100"
cellTemplate="cellTemplate"
></dxi-data-grid-column>
<div *dxTemplate="let cell of 'cellTemplate'">
<a href="{{ cell.text }}" target="_blank">Website</a>
</div>
<dxo-data-grid-summary>
<dxi-data-grid-total-item
column="Name"
summaryType="count"
displayFormat="Total count: {0}"
></dxi-data-grid-total-item>
</dxo-data-grid-summary>
</dx-data-grid>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { jsPDF } from 'jspdf';
import { exportDataGrid } from 'devextreme-angular/common/export/pdf';
import { DxDataGridModule, DxDataGridTypes } from 'devextreme-angular/ui/data-grid';
import { Service, Company } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxDataGridModule,
],
})
export class AppComponent {
companies: Company[];
constructor(service: Service) {
this.companies = service.getCompanies();
}
onExporting(e: DxDataGridTypes.ExportingEvent) {
const doc = new jsPDF();
exportDataGrid({
jsPDFDocument: doc,
component: e.component,
columnWidths: [40, 40, 30, 30, 40],
customizeCell({ gridCell, pdfCell }) {
if (gridCell.rowType === 'data' && gridCell.column.dataField === 'Phone') {
pdfCell.text = pdfCell.text.replace(/(\d{3})(\d{3})(\d{4})/, '($1) $2-$3');
} else if (gridCell.rowType === 'group') {
pdfCell.backgroundColor = '#BEDFE6';
} else if (gridCell.rowType === 'totalFooter') {
pdfCell.font.style = 'italic';
}
},
customDrawCell(options) {
const { gridCell, pdfCell } = options;
if (gridCell.rowType === 'data' && gridCell.column.dataField === 'Website') {
options.cancel = true;
doc.setFontSize(11);
doc.setTextColor('#0000FF');
const textHeight = doc.getTextDimensions(pdfCell.text).h;
doc.textWithLink('website',
options.rect.x + pdfCell.padding.left,
options.rect.y + options.rect.h / 2 + textHeight / 2,
{ url: pdfCell.text });
}
},
}).then(() => {
doc.save('Companies.pdf');
});
}
phoneNumberFormat(value: string) {
const USNumber = value.match(/(\d{3})(\d{3})(\d{4})/);
return `(${USNumber[1]}) ${USNumber[2]}-${USNumber[3]}`;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
#gridContainer {
height: 436px;
}
import { Injectable } from '@angular/core';
export class Company {
ID: number;
Name: string;
Address: string;
City: string;
State: string;
Zipcode: number;
Phone: string;
Fax: string;
Website: string;
}
const companies: Company[] = [{
ID: 1,
Name: 'Super Mart of the West',
Address: '702 SW 8th Street',
City: 'Bentonville',
State: 'Arkansas',
Zipcode: 72716,
Phone: '8005552797',
Fax: '(800) 555-2171',
Website: 'http://nowebsitesupermart.dx',
}, {
ID: 2,
Name: 'Electronics Depot',
Address: '2455 Paces Ferry Road NW',
City: 'Atlanta',
State: 'Georgia',
Zipcode: 30339,
Phone: '8005953232',
Fax: '(800) 595-3231',
Website: 'http://nowebsitedepot.dx',
}, {
ID: 3,
Name: 'K&S Music',
Address: '1000 Nicllet Mall',
City: 'Minneapolis',
State: 'Minnesota',
Zipcode: 55403,
Phone: '6123046073',
Fax: '(612) 304-6074',
Website: 'http://nowebsitemusic.dx',
}, {
ID: 4,
Name: "Tom's Club",
Address: '999 Lake Drive',
City: 'Issaquah',
State: 'Washington',
Zipcode: 98027,
Phone: '8009552292',
Fax: '(800) 955-2293',
Website: 'http://nowebsitetomsclub.dx',
}, {
ID: 5,
Name: 'E-Mart',
Address: '3333 Beverly Rd',
City: 'Hoffman Estates',
State: 'Illinois',
Zipcode: 60179,
Phone: '8472862500',
Fax: '(847) 286-2501',
Website: 'http://nowebsiteemart.dx',
}, {
ID: 6,
Name: 'Walters',
Address: '200 Wilmot Rd',
City: 'Deerfield',
State: 'Illinois',
Zipcode: 60015,
Phone: '8479402500',
Fax: '(847) 940-2501',
Website: 'http://nowebsitewalters.dx',
}, {
ID: 7,
Name: 'StereoShack',
Address: '400 Commerce S',
City: 'Fort Worth',
State: 'Texas',
Zipcode: 76102,
Phone: '8178200741',
Fax: '(817) 820-0742',
Website: 'http://nowebsiteshack.dx',
}, {
ID: 8,
Name: 'Circuit Town',
Address: '2200 Kensington Court',
City: 'Oak Brook',
State: 'Illinois',
Zipcode: 60523,
Phone: '8009552929',
Fax: '(800) 955-9392',
Website: 'http://nowebsitecircuittown.dx',
}, {
ID: 9,
Name: 'Premier Buy',
Address: '7601 Penn Avenue South',
City: 'Richfield',
State: 'Minnesota',
Zipcode: 55423,
Phone: '6122911000',
Fax: '(612) 291-2001',
Website: 'http://nowebsitepremierbuy.dx',
}, {
ID: 10,
Name: 'ElectrixMax',
Address: '263 Shuman Blvd',
City: 'Naperville',
State: 'Illinois',
Zipcode: 60563,
Phone: '6304387800',
Fax: '(630) 438-7801',
Website: 'http://nowebsiteelectrixmax.dx',
}, {
ID: 11,
Name: 'Video Emporium',
Address: '1201 Elm Street',
City: 'Dallas',
State: 'Texas',
Zipcode: 75270,
Phone: '2148543000',
Fax: '(214) 854-3001',
Website: 'http://nowebsitevideoemporium.dx',
}, {
ID: 12,
Name: 'Screen Shop',
Address: '1000 Lowes Blvd',
City: 'Mooresville',
State: 'North Carolina',
Zipcode: 28117,
Phone: '8004456937',
Fax: '(800) 445-6938',
Website: 'http://nowebsitescreenshop.dx',
}];
@Injectable()
export class Service {
getCompanies() {
return companies;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'fflate': 'npm:fflate/esm/browser.js',
'jspdf': 'npm:jspdf@4.2.1/dist/jspdf.umd.min.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.0.2"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.3/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
In this demo, the customizeCell function changes the following elements:
- Background color and font weight of group row cells
- Font style of a footer cell
The customDrawCell function allows you to draw cells in a PDF document. The following parameters are available when you use this function:
- doc
An instance of the jsPDFDocument object. - rect
A cell’s bounds. - gridCell
Contains information about the source DataGrid cell. - pdfCell
Contains settings applied to a cell in a PDF document. - cancel
Set this parameter to true to prevent default painting logic.
This demo uses the customDrawCell function to paint cells in the "Website" column.